//+------------------------------------------------------------------+
//|                                                exp_statusbot.mq5 |
//|                               Leonid Salavatov [MUSTADDON] 2010 |
//+------------------------------------------------------------------+
#property copyright "Leonid Salavatov [MUSTADDON] 2010"
#property link      "mustaddon@gmail.com"
#property version   "1.0"
//---- vars
int         codepage             = CP_ACP;
string      expname              = "statusbot";
string      statusfilename       = "status.txt";
string      spamfilename         = "notify.txt";
string      ar_sSTATUScur[];
string      ar_sSTATUSpast[];
string      ar_sSPAM[];
int         pospast=0;
string      Abzac="------------------";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   ResetLastError();
   string filename=expname+"\\"+spamfilename;
   int filehandle=FileOpen(filename,FILE_WRITE|FILE_TXT|FILE_ANSI,codepage);  
   if(filehandle!=INVALID_HANDLE)
     {FileWrite(filehandle,"Starting expert '"+expname+"'");
      FileClose(filehandle);
     }
   else Print("    ",spamfilename,", ",GetLastError()); 
   return(0);
//---
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   FileDelete(expname+"\\"+statusfilename);
   FileDelete(expname+"\\"+spamfilename);
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   double sumprofit=AccountInfoDouble(ACCOUNT_PROFIT);
   double balance  =AccountInfoDouble(ACCOUNT_BALANCE);
   double equity   =AccountInfoDouble(ACCOUNT_EQUITY);
   string symset,order_type;
   int    tp,sl;
   double vol,open,profit;
//---    status.txt 
   ArrayResize(ar_sSTATUScur,PositionsTotal()); 
   ResetLastError();
   string filename=expname+"\\"+statusfilename;
   int    filehandle=FileOpen(filename,FILE_WRITE|FILE_TXT|FILE_ANSI,codepage);
   FileWrite(filehandle,"Balance = "+DoubleToString(balance,2)+" "+AccountInfoString(ACCOUNT_CURRENCY));
   for(int i=0;i<PositionsTotal() && filehandle!=INVALID_HANDLE;i++)
     {if(i==0)FileWrite(filehandle,Abzac);
      PositionGetSymbol(i);
      if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_BUY) order_type="buy";
      if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_SELL)order_type="sell";
      sl    =PositionGetDouble(POSITION_SL);
      tp    =PositionGetDouble(POSITION_TP);
      vol   =PositionGetDouble(POSITION_VOLUME);
      open  =PositionGetDouble(POSITION_PRICE_OPEN);
      profit=PositionGetDouble(POSITION_PROFIT);
      symset=PositionGetSymbol(i)+"  "+order_type+" "+DoubleToString(vol,2)+"  "+DoubleToString(profit,2)+" "+AccountInfoString(ACCOUNT_CURRENCY);
      FileWrite(filehandle,symset);
      ar_sSTATUScur[i]=symset;
      if(i==PositionsTotal()-1)
        {FileWrite(filehandle,"summa = "+DoubleToString(sumprofit,2)+" "+AccountInfoString(ACCOUNT_CURRENCY));
         FileWrite(filehandle,Abzac);
         FileWrite(filehandle,"Equity = "+DoubleToString(equity,2)+" "+AccountInfoString(ACCOUNT_CURRENCY));
        }
     }
   FileClose(filehandle);
 //---
   if(pospast==0 && PositionsTotal()==0) return;
 //---    
   ArrayResize(ar_sSPAM,PositionsTotal()+pospast);

   int j,changing=0;
   for(int i=0;i<PositionsTotal();i++)
     {for(j=0;j<pospast;j++) {if(StringSubstr(ar_sSTATUScur[i],0,6)==StringSubstr(ar_sSTATUSpast[j],0,6))break;}
      if(j==pospast)
        {ar_sSPAM[changing]="[position added] "+ar_sSTATUScur[i];
         changing++;} 
     }
   for(int i=0;i<pospast;i++)
     {for(j=0;j<PositionsTotal();j++){if(StringSubstr(ar_sSTATUScur[j],0,6)==StringSubstr(ar_sSTATUSpast[i],0,6))break;}
      if(j==PositionsTotal())
        {ar_sSPAM[changing]="[position closed] "+ar_sSTATUSpast[i];
         changing++;} 
     }
//---
   ArrayResize(ar_sSTATUSpast,ArraySize(ar_sSTATUScur));
   if(ArraySize(ar_sSTATUScur)>0) ArrayCopy(ar_sSTATUSpast,ar_sSTATUScur,0,0,WHOLE_ARRAY);
   pospast=PositionsTotal();
   if(changing==0) return;
//---       notify.txt
   ResetLastError();
   filename=expname+"\\"+spamfilename;
   filehandle=FileOpen(filename,FILE_WRITE|FILE_TXT|FILE_ANSI,codepage);  
   if(filehandle!=INVALID_HANDLE)
     {for(int i=0;i<changing;i++)
        {FileWrite(filehandle,ar_sSPAM[i]);}
      FileClose(filehandle);
     }
   else Print("    ",spamfilename,", ",GetLastError()); 
//---
  }
//+------------------------------------------------------------------+